"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InheritKeywords = void 0;
var _immutable = require("immutable");
var InheritKeywords = exports.InheritKeywords = function InheritKeywords(keywords, should) {
  return {
    handle: function handle(props) {
      if (should && !should(props)) return null;
      var parentSchema = props.parentSchema,
        schema = props.schema;
      var newSchema = schema;
      if (parentSchema) {
        keywords.forEach(function (keyword) {
          var foundKeyword = Array.isArray(keyword) ? parentSchema.getIn(keyword) : parentSchema.get(keyword);
          if (foundKeyword !== undefined) {
            newSchema || (newSchema = (0, _immutable.OrderedMap)());
            newSchema = Array.isArray(keyword) ? newSchema.setIn(keyword, foundKeyword) : newSchema.set(keyword, foundKeyword);
          }
        });
      }
      return {
        schema: newSchema
      };
    }
  };
};