"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.requiredPlugin = void 0;
var _immutable = require("immutable");
var requiredPlugin = exports.requiredPlugin = {
  handle: function handle(_ref) {
    var parentSchema = _ref.parentSchema,
      storeKeys = _ref.storeKeys;
    var requiredList = parentSchema === null || parentSchema === void 0 ? void 0 : parentSchema.get('required');
    if (!requiredList || !_immutable.List.isList(requiredList) || !storeKeys) {
      return {
        required: false
      };
    }
    var ownKey = storeKeys.last();
    return {
      required: typeof ownKey === 'string' && requiredList.contains(ownKey)
    };
  }
};