import { List } from 'immutable';
export const requiredPlugin = {
  handle: ({
    parentSchema,
    storeKeys
  }) => {
    const requiredList = parentSchema?.get('required');
    if (!requiredList || !List.isList(requiredList) || !storeKeys) {
      return {
        required: false
      };
    }
    const ownKey = storeKeys.last();
    return {
      required: typeof ownKey === 'string' && requiredList.contains(ownKey)
    };
  }
};