import { OrderedMap } from 'immutable';
export const SortPlugin = {
  handle: ({
    schema
  }) => {
    const sortOrder = schema?.get('sortOrder');
    if (!sortOrder) return {};
    const keys = schema.get('properties')?.keySeq();
    if (!keys) return {};
    const nonSortedProps = keys.filter(k => !sortOrder.includes(k));
    return {
      schema: schema.set('properties', sortOrder.filter(key => keys.includes(key)).concat(nonSortedProps).reduce((properties, key) => properties.set(key, schema.getIn(['properties', key])), OrderedMap()))
    };
  }
};