"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.standardValidators = void 0;
var _toPointer = require("@ui-schema/json-pointer/toPointer");
var _Validator = require("@ui-schema/json-schema/Validator");
var _Validators = require("@ui-schema/json-schema/Validators");
var _ValidatorOutput = require("@ui-schema/ui-schema/ValidatorOutput");
var _immutable = require("immutable");
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var standardValidators = exports.standardValidators = [{
  id: 'ref',
  validate: function validate(schema, value, params) {
    var _params$resource;
    if (!schema.has('$ref')) return;
    var refSchema = (_params$resource = params.resource) === null || _params$resource === void 0 ? void 0 : _params$resource.findRef(schema.get('$ref'));
    var applied = [];
    if (refSchema) {
      var result = params.validate(refSchema.value(), value, _objectSpread(_objectSpread({}, params), {}, {
        keywordLocation: [].concat(_toConsumableArray(params.keywordLocation), ['$ref']),
        parentSchema: undefined
      }));
      applied.push(refSchema.value());
      applied.push.apply(applied, _toConsumableArray(result.applied || []));
    }
    return {
      applied: applied
    };
  }
}, {
  id: 'type',
  validate: function validate(schema, value, params) {
    var type = schema.get('type');
    if (!type) return;
    if (typeof value === 'undefined' && type && params.instanceLocation.length === 0) {
      params.output.addError({
        error: _Validators.ERROR_WRONG_TYPE,
        keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['type'])),
        instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation),
        context: {
          actual: 'undefined'
        }
      });
      return;
    }
    if (typeof type !== 'undefined' && !(0, _Validators.validateTypes)(value, type)) {
      params.output.addError({
        error: _Validators.ERROR_WRONG_TYPE,
        keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['type'])),
        instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation),
        context: {
          actual: (0, _Validator.getValueType)(value)
        }
      });
    }
  }
}, {
  validate: function validate(schema, value, params) {
    var not = schema.get('not');
    if (!not || typeof value === 'undefined') return;
    var tmpNot = params.validate(not, value, _objectSpread(_objectSpread({}, params), {}, {
      keywordLocation: [].concat(_toConsumableArray(params.keywordLocation), ['not']),
      parentSchema: undefined,
      output: new _ValidatorOutput.ValidatorOutput(),
      context: {}
    }));
    if (tmpNot.valid) {
      params.output.addError({
        error: 'not-is-valid',
        keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['not'])),
        instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation)
      });
    }
  }
}, {
  types: ['string'],
  validate: function validate(schema, value, params) {
    if (!schema.has('pattern')) return;
    if (!(0, _Validators.validatePattern)(value, schema.get('pattern'))) {
      params.output.addError({
        error: _Validators.ERROR_PATTERN,
        keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['pattern'])),
        instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation),
        context: {
          pattern: schema.get('pattern'),
          patternError: schema.get('patternError')
        }
      });
    }
  }
}, {
  validate: function validate(schema, value, params) {
    if (!schema.has('const')) return;
    if (!(0, _Validators.validateConst)(schema.get('const'), value)) {
      params.output.addError({
        error: _Validators.ERROR_CONST_MISMATCH,
        keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['const'])),
        instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation),
        context: {
          "const": schema.get('const')
        }
      });
    }
  }
}, {
  validate: function validate(schema, value, params) {
    if (!schema.has('enum')) return;
    if (!(0, _Validators.validateEnum)(schema.get('enum'), value)) {
      params.output.addError({
        error: _Validators.ERROR_ENUM_MISMATCH,
        keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['enum'])),
        instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation),
        context: {
          "enum": schema.get('enum')
        }
      });
    }
  }
}, {
  types: ['number'],
  validate: function validate(schema, value, params) {
    if (!schema.has('multipleOf')) return;
    if (!(0, _Validators.validateMultipleOf)(schema.get('multipleOf'), value)) {
      params.output.addError({
        error: _Validators.ERROR_MULTIPLE_OF,
        keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['multipleOf'])),
        instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation),
        context: {
          multipleOf: schema.get('multipleOf')
        }
      });
    }
  }
}, {
  types: ['string'],
  validate: function validate(schema, value, params) {
    if (!['minLength', 'maxLength'].some(function (keyword) {
      return schema.has(keyword);
    })) return;
    (0, _Validators.validateMinMaxString)(schema, value, params.output);
  }
}, {
  types: ['number'],
  validate: function validate(schema, value, params) {
    if (!['minimum', 'exclusiveMinimum', 'maximum', 'exclusiveMaximum'].some(function (keyword) {
      return schema.has(keyword);
    })) return;
    (0, _Validators.validateMinMaxNumber)(schema, value, params.output);
  }
}, {
  types: ['array'],
  validate: function validate(schema, value, params) {
    if (!['minItems', 'maxItems'].some(function (keyword) {
      return schema.has(keyword);
    })) return;
    (0, _Validators.validateMinMaxArray)(schema, value, params.output);
  }
}, {
  types: ['object'],
  validate: function validate(schema, value, params) {
    if (!['minProperties', 'maxProperties'].some(function (keyword) {
      return schema.has(keyword);
    })) return;
    (0, _Validators.validateMinMaxObject)(schema, value, params.output);
  }
}, {
  types: ['array'],
  validate: function validate(schema, value, params) {
    if (!['contains', 'minContains', 'maxContains'].some(function (keyword) {
      return schema.has(keyword);
    })) return;
    (0, _Validators.validateContains)(schema, value, params);
  }
}, {
  id: 'required',
  validate: function validate(schema, value, params) {
    var requiredList = schema === null || schema === void 0 ? void 0 : schema.get('required');
    if (!requiredList || params.recursive && !value) return;
    if (_immutable.Map.isMap(value) || _immutable.Record.isRecord(value)) {
      requiredList.forEach(function (requiredKey) {
        if (!value.has(requiredKey)) {
          params.output.addError({
            error: _Validators.ERROR_NOT_SET,
            keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['required'])),
            instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation),
            context: {
              requiredKey: requiredKey
            }
          });
        }
      });
    } else if (_typeof(value) === 'object' && !Array.isArray(value)) {
      requiredList.forEach(function (requiredKey) {
        if (!Object.hasOwnProperty.call(value, requiredKey)) {
          params.output.addError({
            error: _Validators.ERROR_NOT_SET,
            keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['required'])),
            instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation),
            context: {
              requiredKey: requiredKey
            }
          });
        }
      });
    } else if (typeof value === 'undefined' || value === null) {
      requiredList.forEach(function (requiredKey) {
        params.output.addError({
          error: _Validators.ERROR_NOT_SET,
          keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['required'])),
          instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation),
          context: {
            requiredKey: requiredKey
          }
        });
      });
    }
  }
}, _Validators.arrayValidator, _Validators.objectValidator, {
  id: 'unevaluatedProperties',
  types: ['object'],
  validate: function validate(schema, value, params) {
    if (schema.get('unevaluatedProperties') === false && _immutable.Map.isMap(value) && value.size) {
      return {
        afterAll: function afterAll(result) {
          var _result$context;
          var keys = value.keys();
          var evaluatedProperties = (_result$context = result.context) === null || _result$context === void 0 ? void 0 : _result$context.evaluatedProperties;
          if (!evaluatedProperties) {
            params.output.addError({
              error: 'unevaluated-property',
              context: {
                keys: Array.from(keys)
              }
            });
            return;
          }
          var _iterator = _createForOfIteratorHelper(keys),
            _step;
          try {
            for (_iterator.s(); !(_step = _iterator.n()).done;) {
              var key = _step.value;
              if (!evaluatedProperties.has(key)) {
                params.output.addError({
                  error: 'unevaluated-property',
                  context: {
                    key: key
                  }
                });
                break;
              }
            }
          } catch (err) {
            _iterator.e(err);
          } finally {
            _iterator.f();
          }
        }
      };
    }
  }
}, {
  id: 'if',
  validate: function validate(schema, value, params) {
    var keyIf = schema.get('if');
    if (!keyIf || typeof value === 'undefined') return undefined;
    var keyThen = schema.get('then');
    var keyElse = schema.get('else');
    var tmpIf = params.validate(keyIf, value, _objectSpread(_objectSpread({}, params), {}, {
      keywordLocation: [].concat(_toConsumableArray(params.keywordLocation), ['if']),
      instanceLocation: [],
      instanceKey: undefined,
      parentSchema: undefined,
      recursive: true,
      output: new _ValidatorOutput.ValidatorOutput(),
      context: {}
    }));
    if (tmpIf.valid) {
      if (keyThen) {
        var result = params.validate(keyThen, value, _objectSpread(_objectSpread({}, params), {}, {
          keywordLocation: [].concat(_toConsumableArray(params.keywordLocation), ['then']),
          parentSchema: undefined
        }));
        return {
          applied: [keyThen].concat(_toConsumableArray(result.applied || []))
        };
      }
    } else {
      if (keyElse) {
        var _result = params.validate(keyElse, value, _objectSpread(_objectSpread({}, params), {}, {
          keywordLocation: [].concat(_toConsumableArray(params.keywordLocation), ['else']),
          parentSchema: undefined
        }));
        return {
          applied: [keyElse].concat(_toConsumableArray(_result.applied || []))
        };
      }
    }
  }
}, _Validators.oneOfValidator, {
  id: 'allOf',
  validate: function validate(schema, value, params) {
    var schemas = schema.get('allOf');
    if (!schemas) return undefined;
    var applied = _toConsumableArray(schemas.toArray());
    if (_immutable.List.isList(schemas)) {
      var _iterator2 = _createForOfIteratorHelper(schemas),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _schema = _step2.value;
          var result = params.validate(_schema, value, _objectSpread(_objectSpread({}, params), {}, {
            keywordLocation: [].concat(_toConsumableArray(params.keywordLocation), ['allOf']),
            parentSchema: undefined
          }));
          applied.push.apply(applied, _toConsumableArray(result.applied || []));
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    }
    return {
      applied: applied
    };
  }
}, {
  id: 'anyOf',
  validate: function validate(schema, value, params) {
    var schemas = schema.get('anyOf');
    if (!schemas) return undefined;
    var errorCount = 0;
    var appliedSchema = undefined;
    var output = new _ValidatorOutput.ValidatorOutput();
    if (_immutable.List.isList(schemas)) {
      var _iterator3 = _createForOfIteratorHelper(schemas),
        _step3;
      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var _schema2 = _step3.value;
          var context = {};
          var result = params.validate(_schema2, value, _objectSpread(_objectSpread({}, params), {}, {
            keywordLocation: [].concat(_toConsumableArray(params.keywordLocation), ['anyOf']),
            parentSchema: undefined,
            recursive: true,
            output: new _ValidatorOutput.ValidatorOutput(),
            context: context
          }));
          if (result.valid) {
            errorCount = 0;
            appliedSchema = _schema2;
            break;
          } else {
            errorCount++;
            result.errors.forEach(function (err) {
              return output.addError(err);
            });
          }
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
    }
    if (errorCount) {
      output.errors.forEach(function (err) {
        return params.output.addError(err);
      });
    }
    return {
      applied: [appliedSchema]
    };
  }
}, {
  id: 'dependent',
  validate: function validate(schema, value, params) {
    var dependencies = schema.get('dependencies');
    var dependentSchemas = schema.get('dependentSchemas');
    var dependentRequired = schema.get('dependentRequired');
    if (!_immutable.Map.isMap(value)) return;
    if (!dependencies && !dependentSchemas && !dependentRequired) return;
    var applied = [];
    value.keySeq().forEach(function (key) {
      var key_dependencies = dependencies ? dependencies.get(key) : undefined;
      var key_dependentSchemas = dependentSchemas ? dependentSchemas.get(key) : _immutable.Map.isMap(key_dependencies) ? key_dependencies : undefined;
      var key_dependentRequired = dependentRequired ? dependentRequired.get(key) : _immutable.List.isList(key_dependencies) ? key_dependencies : undefined;
      if (typeof value.get(key) !== 'undefined') {
        if (key_dependentSchemas) {
          applied.push(key_dependentSchemas);
          var result = params.validate(key_dependentSchemas, value, _objectSpread(_objectSpread({}, params), {}, {
            keywordLocation: [].concat(_toConsumableArray(params.keywordLocation), ['dependentRequired']),
            instanceLocation: [],
            instanceKey: undefined,
            parentSchema: undefined
          }));
          applied.push.apply(applied, _toConsumableArray(result.applied || []));
        }
        if (key_dependentRequired) {
          applied.push((0, _immutable.Map)({
            required: key_dependentRequired
          }));
          key_dependentRequired.forEach(function (req) {
            if (typeof value.get(req) === 'undefined') {
              params.output.addError({
                error: _Validators.ERROR_NOT_SET,
                keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['dependentRequired', key])),
                instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation)
              });
            }
          });
        }
      }
    });
    return {
      applied: applied
    };
  }
}];