"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Validator = Validator;
exports.createRegister = createRegister;
exports.makeParams = makeParams;
var _ValidatorOutput = require("@ui-schema/ui-schema/ValidatorOutput");
var _getValueType = require("./getValueType.cjs");
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function deduplicateByLast(array) {
  var map = new Map();
  var _iterator = _createForOfIteratorHelper(array),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var item = _step.value;
      map.set(item.id || Symbol(), item);
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return Array.from(map.values());
}
function createRegister(validators) {
  var register = deduplicateByLast(validators).reduce(function (register, validator) {
    if (validator.types) {
      var _validator$types;
      (_validator$types = validator.types) === null || _validator$types === void 0 || _validator$types.forEach(function (type) {
        if (!register.valueHandlers.has(type)) {
          register.valueHandlers.set(type, []);
        }
        register.valueHandlers.get(type).push(validator.validate);
      });
    } else {
      register.handlers.push(validator.validate);
    }
    return register;
  }, {
    valueHandlers: new Map(),
    handlers: [],
    toJSON: function toJSON() {
      return registerToJSON(register, validators);
    }
  });
  return register;
}
function makeParams() {
  return {
    instanceLocation: [],
    keywordLocation: []
  };
}
function Validator(validators) {
  var register = createRegister(validators);
  function validate(schema, value) {
    var params = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : makeParams();
    var scopedParams = _objectSpread(_objectSpread({}, params), {}, {
      context: params.context || {},
      output: params.output || new _ValidatorOutput.ValidatorOutput(),
      validate: params.validate || validate
    });
    var applied = [];
    var afterAll = [];
    var _iterator2 = _createForOfIteratorHelper(register.handlers),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var _validator = _step2.value;
        var _result = _validator(schema, value, scopedParams);
        applied.push.apply(applied, _toConsumableArray((_result === null || _result === void 0 ? void 0 : _result.applied) || []));
        if (_result !== null && _result !== void 0 && _result.afterAll) {
          afterAll.push(_result.afterAll);
        }
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    var valueType = (0, _getValueType.getValueType)(value);
    if (valueType) {
      var _validators = register.valueHandlers.get(valueType);
      if (_validators) {
        var _iterator3 = _createForOfIteratorHelper(_validators),
          _step3;
        try {
          for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
            var validator = _step3.value;
            var result = validator(schema, value, scopedParams);
            applied.push.apply(applied, _toConsumableArray((result === null || result === void 0 ? void 0 : result.applied) || []));
            if (result !== null && result !== void 0 && result.afterAll) {
              afterAll.push(result.afterAll);
            }
          }
        } catch (err) {
          _iterator3.e(err);
        } finally {
          _iterator3.f();
        }
      }
    }
    afterAll.forEach(function (afterAllValidator) {
      afterAllValidator({
        context: scopedParams.context,
        output: scopedParams.output
      });
    });
    if (scopedParams.output.errCount) {
      return {
        valid: false,
        errors: scopedParams.output.errors,
        applied: applied
      };
    }
    return {
      valid: true,
      value: value,
      applied: applied
    };
  }
  var _validateValue = function validateValue(schema, value, params) {
    var output = new _ValidatorOutput.ValidatorOutput();
    _validateValue.errors = output.errors;
    _validateValue.annotations = output.annotations;
    return validate(schema, value, _objectSpread(_objectSpread({
      instanceLocation: [],
      keywordLocation: []
    }, params || {}), {}, {
      output: output
    })).valid;
  };
  _validateValue.errors = [];
  _validateValue.annotations = [];
  return {
    validateValue: _validateValue,
    validate: validate
  };
}
function mapToObject(map, valueConverter) {
  var obj = {};
  var _iterator4 = _createForOfIteratorHelper(map.entries()),
    _step4;
  try {
    for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
      var _step4$value = _slicedToArray(_step4.value, 2),
        key = _step4$value[0],
        _value = _step4$value[1];
      obj[String(key)] = valueConverter(_value);
    }
  } catch (err) {
    _iterator4.e(err);
  } finally {
    _iterator4.f();
  }
  return obj;
}
function serializeValidatorsArray(validatorFns) {
  return function serializeValidatorsArray2(validators) {
    return validators.map(function (v) {
      return "[Validator Function ".concat(validatorFns.indexOf(v), "]");
    });
  };
}
var registerToJSON = function registerToJSON(register, validators) {
  var validatorFns = validators.map(function (v) {
    return v.validate;
  });
  return {
    valueHandlers: mapToObject(register.valueHandlers, serializeValidatorsArray(validatorFns)),
    handlers: serializeValidatorsArray(validatorFns)(register.handlers)
  };
};