"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getValueType = getValueType;
var _immutable = require("immutable");
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var jsonTypes = {
  string: 'string',
  number: 'number',
  "boolean": 'boolean'
};
function getValueType(value) {
  if (value === null) {
    return 'null';
  }
  if (_immutable.List.isList(value)) {
    return 'array';
  }
  if (_immutable.Map.isMap(value) || _immutable.Record.isRecord(value)) {
    return 'object';
  }
  if (_typeof(value) === 'object') {
    return Array.isArray(value) ? 'array' : 'object';
  }
  var type = _typeof(value);
  if (type in jsonTypes) {
    return jsonTypes[type];
  }
  return undefined;
}