"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validateUniqueItems = exports.validateItems = exports.validateContains = exports.validateArrayContent = exports.validateAdditionalItems = exports.arrayValidator = exports.ERROR_NOT_FOUND_CONTAINS = exports.ERROR_MIN_CONTAINS = exports.ERROR_MAX_CONTAINS = exports.ERROR_DUPLICATE_ITEMS = exports.ERROR_ADDITIONAL_ITEMS = void 0;
var _toPointer = require("@ui-schema/json-pointer/toPointer");
var _Validator = require("@ui-schema/json-schema/Validator");
var _ValidatorOutput = require("@ui-schema/ui-schema/ValidatorOutput");
var _immutable = require("immutable");
var _TypeValidator = require("@ui-schema/json-schema/Validators/TypeValidator");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var ERROR_DUPLICATE_ITEMS = exports.ERROR_DUPLICATE_ITEMS = 'duplicate-items';
var ERROR_NOT_FOUND_CONTAINS = exports.ERROR_NOT_FOUND_CONTAINS = 'not-found-contains';
var ERROR_MIN_CONTAINS = exports.ERROR_MIN_CONTAINS = 'min-contains';
var ERROR_MAX_CONTAINS = exports.ERROR_MAX_CONTAINS = 'max-contains';
var ERROR_ADDITIONAL_ITEMS = exports.ERROR_ADDITIONAL_ITEMS = 'additional-items';
var findDuplicates = function findDuplicates(arr) {
  return arr.filter(function (item, index) {
    return arr.indexOf(item) !== index;
  });
};
var validateArrayContent = exports.validateArrayContent = function validateArrayContent(itemsSchema, value) {
  var additionalItems = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  var params = arguments.length > 3 ? arguments[3] : undefined;
  var output = 'output' in params && params.output ? params.output : new _ValidatorOutput.ValidatorOutput();
  var found = 0;
  if (_immutable.List.isList(itemsSchema)) {
    if (_immutable.List.isList(value) || Array.isArray(value)) {
      if (!validateAdditionalItems(additionalItems, value, itemsSchema)) {
        output.addError({
          error: ERROR_ADDITIONAL_ITEMS,
          keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['additionalItems'])),
          instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation)
        });
        found++;
      }
      if (params.recursive) {
        var listSize = itemsSchema.size || 0;
        var i = 0;
        var _iterator = _createForOfIteratorHelper(value),
          _step;
        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var val = _step.value;
            if (i >= listSize) break;
            var result = params.validate(itemsSchema.get(i), val, _objectSpread(_objectSpread({}, params), {}, {
              keywordLocation: [].concat(_toConsumableArray(params.keywordLocation), ['items']),
              instanceLocation: [].concat(_toConsumableArray(params.instanceLocation), [i]),
              instanceKey: i,
              output: 'output' in params && params.output ? params.output : new _ValidatorOutput.ValidatorOutput(),
              context: {}
            }));
            if (result.valid) {
              found++;
            } else if (!('output' in params && params.output)) {
              result.errors.forEach(function (err2) {
                return output.addError(err2);
              });
            }
            i++;
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      }
    } else {
      output.addError({
        error: _TypeValidator.ERROR_WRONG_TYPE,
        context: {
          actual: (0, _Validator.getValueType)(value),
          arrayTupleValidation: true
        }
      });
      found++;
    }
  } else if (Array.isArray(value) || _immutable.List.isList(value)) {
    var _i = 0;
    var _iterator2 = _createForOfIteratorHelper(value),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var _val = _step2.value;
        var _result = params.validate(itemsSchema, _val, _objectSpread(_objectSpread({}, params), {}, {
          keywordLocation: [].concat(_toConsumableArray(params.keywordLocation), ['items']),
          instanceLocation: [].concat(_toConsumableArray(params.instanceLocation), [_i]),
          instanceKey: _i,
          output: 'output' in params && params.output ? params.output : new _ValidatorOutput.ValidatorOutput(),
          context: {}
        }));
        if (_result.valid) {
          found++;
        } else if (!('output' in params && params.output)) {
          _result.errors.forEach(function (err2) {
            return output.addError(err2);
          });
        }
        _i++;
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
  }
  return {
    output: output,
    found: found
  };
};
var validateAdditionalItems = exports.validateAdditionalItems = function validateAdditionalItems(additionalItems, value, schema) {
  return additionalItems || !additionalItems && (_immutable.List.isList(value) && value.size <= schema.size || Array.isArray(value) && value.length <= schema.size);
};
var validateItems = exports.validateItems = function validateItems(schema, value, params) {
  var items = schema.get('items');
  if (items && value) {
    validateArrayContent(items, value, schema.get('additionalItems'), _objectSpread(_objectSpread({}, params), {}, {
      parentSchema: schema
    }));
  }
};
var validateContains = exports.validateContains = function validateContains(schema, value, params) {
  if (!(Array.isArray(value) || _immutable.List.isList(value))) return;
  var contains = schema.get('contains');
  if (!contains) return;
  var contains_type = contains.get('type');
  if (!contains_type) return;
  var minContains = schema.get('minContains');
  var maxContains = schema.get('maxContains');
  var item_err = validateArrayContent(contains, value, undefined, _objectSpread(_objectSpread({}, params), {}, {
    parentSchema: schema,
    keywordLocation: [].concat(_toConsumableArray(params.keywordLocation), ['contains']),
    recursive: true,
    output: undefined,
    context: {}
  }));
  if (item_err.found < 1 && typeof minContains === 'undefined' && typeof maxContains === 'undefined' || typeof minContains === 'number' && minContains > item_err.found || typeof maxContains === 'number' && maxContains < item_err.found) {
    if (item_err.output.errCount !== 0) {
      item_err.output.errors.forEach(function (err) {
        return params.output.addError(err);
      });
    }
  }
  if (typeof minContains === 'number' && minContains > item_err.found) {
    params.output.addError({
      error: ERROR_MIN_CONTAINS,
      keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['minContains'])),
      instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation),
      context: {
        minContains: minContains
      }
    });
  }
  if (typeof maxContains === 'number' && maxContains < item_err.found) {
    params.output.addError({
      error: ERROR_MAX_CONTAINS,
      keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['maxContains'])),
      instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation),
      context: {
        maxContains: maxContains
      }
    });
  }
  if (minContains !== 0 && (Array.isArray(value) && value.length === 0 || _immutable.List.isList(value) && value.size === 0)) {
    params.output.addError({
      error: ERROR_NOT_FOUND_CONTAINS,
      keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['contains'])),
      instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation)
    });
  }
};
var validateUniqueItems = exports.validateUniqueItems = function validateUniqueItems(schema, value) {
  var uniqueItems = schema.get('uniqueItems');
  if (uniqueItems && (_immutable.List.isList(value) || Array.isArray(value))) {
    var duplicates = findDuplicates(value);
    if (Array.isArray(duplicates)) {
      return duplicates.length === 0;
    } else if (_immutable.List.isList(duplicates)) {
      return duplicates.size === 0;
    }
  }
  return true;
};
var arrayValidator = exports.arrayValidator = {
  types: ['array'],
  validate: function validate(schema, value, params) {
    if (!schema || !value) return;
    var uniqueItems = schema === null || schema === void 0 ? void 0 : schema.get('uniqueItems');
    if (uniqueItems) {
      if (!validateUniqueItems(schema, value)) {
        params.output.addError({
          error: ERROR_DUPLICATE_ITEMS,
          keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['uniqueItems'])),
          instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation)
        });
      }
    }
    var items = schema === null || schema === void 0 ? void 0 : schema.get('items');
    if (items && params.recursive) {
      validateItems(schema, value, params);
    }
    var contains = schema === null || schema === void 0 ? void 0 : schema.get('contains');
    if (contains) {
      validateContains(schema, value, params);
    }
  }
};