"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validateEmail = exports.emailValidator = exports.ERROR_EMAIL_INVALID = void 0;
var _toPointer = require("@ui-schema/json-pointer/toPointer");
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var ERROR_EMAIL_INVALID = exports.ERROR_EMAIL_INVALID = 'email-invalid';
var validateEmail = exports.validateEmail = function validateEmail(value) {
  if (typeof value === 'string' && !/^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(value)) {
    return false;
  }
  return true;
};
var emailValidator = exports.emailValidator = {
  id: 'format:email',
  types: ['string'],
  validate: function validate(schema, value, params) {
    if (schema.get('format') !== 'email') return;
    if (!validateEmail(value)) {
      params.output.addError({
        error: ERROR_EMAIL_INVALID,
        keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['format'])),
        instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation)
      });
    }
  }
};