"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validateMinMaxObject = void 0;
var _MinMaxValidatorErrorCodes = require("./MinMaxValidatorErrorCodes.cjs");
var _immutable = require("immutable");
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var validateMinMaxObject = exports.validateMinMaxObject = function validateMinMaxObject(schema, value, output) {
  if (typeof value === 'undefined') return;
  var minProperties = schema.get('minProperties');
  var maxProperties = schema.get('maxProperties');
  if (minProperties) {
    if (_immutable.Map.isMap(value) || _immutable.Record.isRecord(value)) {
      if ((value.toSeq().keySeq().size || 0) < minProperties) {
        output.addError({
          error: _MinMaxValidatorErrorCodes.ERROR_MIN_LENGTH,
          context: {
            min: minProperties
          }
        });
      }
    } else if (_typeof(value) === 'object') {
      if (Object.keys(value).length < minProperties) {
        output.addError({
          error: _MinMaxValidatorErrorCodes.ERROR_MIN_LENGTH,
          context: {
            min: minProperties
          }
        });
      }
    }
  }
  if (maxProperties) {
    if (_immutable.Map.isMap(value) || _immutable.Record.isRecord(value)) {
      if ((value.toSeq().keySeq().size || 0) > maxProperties) {
        output.addError({
          error: _MinMaxValidatorErrorCodes.ERROR_MAX_LENGTH,
          context: {
            max: maxProperties
          }
        });
      }
    } else if (_typeof(value) === 'object') {
      if (Object.keys(value).length > maxProperties) {
        output.addError({
          error: _MinMaxValidatorErrorCodes.ERROR_MAX_LENGTH,
          context: {
            max: maxProperties
          }
        });
      }
    }
  }
};