"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validateMinMaxString = void 0;
var _MinMaxValidatorErrorCodes = require("./MinMaxValidatorErrorCodes.cjs");
var validateMinMaxString = exports.validateMinMaxString = function validateMinMaxString(schema, value, output) {
  if (typeof value === 'undefined') return;
  if (typeof value === 'string') {
    var minLength = schema.get('minLength');
    var maxLength = schema.get('maxLength');
    if (minLength) {
      if (value.length < minLength) {
        output.addError({
          error: _MinMaxValidatorErrorCodes.ERROR_MIN_LENGTH,
          context: {
            min: minLength
          }
        });
      }
    }
    if (maxLength) {
      if (value.length > maxLength) {
        output.addError({
          error: _MinMaxValidatorErrorCodes.ERROR_MAX_LENGTH,
          context: {
            max: maxLength
          }
        });
      }
    }
  }
};