import { ERROR_MAX_LENGTH, ERROR_MIN_LENGTH } from './MinMaxValidatorErrorCodes.js';
export const validateMinMaxString = (schema, value, output) => {
  if (typeof value === 'undefined') return;
  if (typeof value === 'string') {
    const minLength = schema.get('minLength');
    const maxLength = schema.get('maxLength');
    if (minLength) {
      if (value.length < minLength) {
        output.addError({
          error: ERROR_MIN_LENGTH,
          context: {
            min: minLength
          }
        });
      }
    }
    if (maxLength) {
      if (value.length > maxLength) {
        output.addError({
          error: ERROR_MAX_LENGTH,
          context: {
            max: maxLength
          }
        });
      }
    }
  }
};