"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validateMultipleOf = exports.ERROR_MULTIPLE_OF = void 0;
var ERROR_MULTIPLE_OF = exports.ERROR_MULTIPLE_OF = 'multiple-of';
var getScale = function getScale(n) {
  var s = n.toString().split('.')[1];
  return s ? Math.pow(10, s.length) : 1;
};
var validateMultipleOf = exports.validateMultipleOf = function validateMultipleOf(multipleOf, value) {
  if (typeof value === 'number' && typeof multipleOf === 'number') {
    if (!Number.isFinite(value) || !Number.isFinite(multipleOf) || multipleOf === 0) return false;
    var scale = Math.max(getScale(value), getScale(multipleOf));
    var scaledValue = BigInt(Math.round(value * scale));
    var scaledMultipleOf = BigInt(Math.round(multipleOf * scale));
    return scaledValue % scaledMultipleOf === 0n;
  }
  return true;
};