"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validateObject = exports.objectValidator = exports.ERROR_ADDITIONAL_PROPERTIES = void 0;
var _toPointer = require("@ui-schema/json-pointer/toPointer");
var _immutable = require("immutable");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var ERROR_ADDITIONAL_PROPERTIES = exports.ERROR_ADDITIONAL_PROPERTIES = 'additional-properties';
var validateObject = exports.validateObject = function validateObject(schema, value, params) {
  var isRealObject = typeof value !== 'undefined' && (_typeof(value) === 'object' && value !== null || _immutable.Map.isMap(value) || _immutable.Record.isRecord(value)) && !(_immutable.List.isList(value) || Array.isArray(value));
  var properties = schema.get('properties');
  if (schema.get('additionalProperties') === false && properties && isRealObject) {
    var hasAdditional = false;
    var valueProperties = _immutable.Map.isMap(value) || _immutable.Record.isRecord(value) ? value.toSeq().keySeq() : Object.keys(value);
    var schemaProperties = properties.keySeq();
    valueProperties.forEach(function (key) {
      if ((schemaProperties === null || schemaProperties === void 0 ? void 0 : schemaProperties.indexOf(key)) === -1) hasAdditional = true;
    });
    if (hasAdditional) {
      params.output.addError({
        error: ERROR_ADDITIONAL_PROPERTIES,
        keywordLocation: (0, _toPointer.toPointer)([].concat(_toConsumableArray(params.keywordLocation), ['additionalProperties'])),
        instanceLocation: (0, _toPointer.toPointer)(params.instanceLocation)
      });
    }
  }
  var propertyNames = schema.get('propertyNames');
  if (propertyNames && isRealObject) {
    var keys = _immutable.Map.isMap(value) || _immutable.Record.isRecord(value) ? value.toSeq().keySeq() : Object.keys(value);
    keys.forEach(function (key) {
      params.validate(propertyNames.set('type', 'string'), key, _objectSpread(_objectSpread({}, params), {}, {
        keywordLocation: [].concat(_toConsumableArray(params.keywordLocation), ['propertyNames'])
      }));
    });
  }
  if (params.recursive && properties) {
    properties.forEach(function (subSchema, key) {
      var _params$context;
      if (!subSchema || typeof key !== 'string') return;
      var val = isRealObject ? _immutable.Map.isMap(value) || _immutable.Record.isRecord(value) ? value.get(key) : value[key] : undefined;
      params.validate(subSchema, val, _objectSpread(_objectSpread({}, params), {}, {
        parentSchema: schema,
        keywordLocation: [].concat(_toConsumableArray(params.keywordLocation), ['properties', key]),
        instanceLocation: [].concat(_toConsumableArray(params.instanceLocation), [key]),
        instanceKey: key,
        context: {}
      }));
      (_params$context = params.context).evaluatedProperties || (_params$context.evaluatedProperties = new Map());
      if (!params.context.evaluatedProperties.has(key)) {
        params.context.evaluatedProperties.set(key, []);
      }
      params.context.evaluatedProperties.get(key).push(subSchema);
    });
  } else {
    properties === null || properties === void 0 || properties.forEach(function (subSchema, key) {
      var _params$context2;
      if (typeof key !== 'string') return;
      (_params$context2 = params.context).evaluatedProperties || (_params$context2.evaluatedProperties = new Map());
      if (!params.context.evaluatedProperties.has(key)) {
        params.context.evaluatedProperties.set(key, []);
      }
      params.context.evaluatedProperties.get(key).push(subSchema);
    });
  }
};
var objectValidator = exports.objectValidator = {
  types: ['object'],
  validate: function validate(schema, value, params) {
    if (!schema) return;
    validateObject(schema, value, params);
  }
};