import { ValidatorOutput } from '@ui-schema/ui-schema/ValidatorOutput';
import { List } from 'immutable';
export const ERROR_ONE_OF_INVALID = 'one-of-is-invalid';
export const validateOneOf = (oneOfSchemas, value, params) => {
  let errorCount = 0;
  const output = new ValidatorOutput();
  if (List.isList(oneOfSchemas)) {
    for (const schema of oneOfSchemas) {
      const result = params.validate(schema, value, {
        ...params,
        keywordLocation: [...params.keywordLocation, 'oneOf'],
        output: new ValidatorOutput(),
        context: {}
      });
      if (result.valid) {
        errorCount = 0;
        break;
      } else {
        errorCount++;
        result.errors.forEach(err => output.addError(err));
      }
    }
  }
  if (errorCount) {
    output.errors.forEach(err => params.output.addError(err));
  }
  return {
    errorCount
  };
};
export const oneOfValidator = {
  validate: (schema, value, params) => {
    const oneOfSchemas = schema?.get('oneOf');
    if (!oneOfSchemas) return;
    validateOneOf(oneOfSchemas, value, {
      ...params,
      recursive: true
    });
  }
};