"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.requiredValidator = exports.checkValueExists = exports.ERROR_NOT_SET = void 0;
var _immutable = require("immutable");
var _schemaTypeIs = require("@ui-schema/ui-schema/schemaTypeIs");
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var ERROR_NOT_SET = exports.ERROR_NOT_SET = 'required-not-set';
var checkValueExists = exports.checkValueExists = function checkValueExists(type, value) {
  var valType = _typeof(value);
  if (valType === 'undefined') {
    return false;
  }
  if ((0, _schemaTypeIs.schemaTypeIs)(type, 'string') && valType === 'string') {
    return value !== '';
  } else if (valType === 'string' && (0, _schemaTypeIs.schemaTypeIsNumeric)(type)) {
    return value !== '';
  }
  return true;
};
var requiredValidator = exports.requiredValidator = {
  handle: function handle(_ref) {
    var parentSchema = _ref.parentSchema,
      schema = _ref.schema,
      storeKeys = _ref.storeKeys,
      value = _ref.value,
      errors = _ref.errors,
      valid = _ref.valid;
    var requiredList = parentSchema === null || parentSchema === void 0 ? void 0 : parentSchema.get('required');
    if (!schema || !requiredList || !_immutable.List.isList(requiredList) || !storeKeys) {
      return {
        required: false
      };
    }
    var ownKey = storeKeys.last();
    if (typeof ownKey !== 'string' || !requiredList.contains(ownKey)) {
      return {
        required: false
      };
    }
    var type = schema.get('type');
    if (!checkValueExists(type, value)) {
      valid = false;
      errors = (errors || (0, _immutable.List)([])).push((0, _immutable.Map)({
        error: ERROR_NOT_SET
      }));
    }
    return {
      errors: errors,
      valid: valid,
      required: true
    };
  }
};