"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validateTypes = exports.validateType = exports.ERROR_WRONG_TYPE = void 0;
var _immutable = require("immutable");
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var ERROR_WRONG_TYPE = exports.ERROR_WRONG_TYPE = 'wrong-type';
var validateType = exports.validateType = function validateType(value, type) {
  if (typeof value === 'undefined' || typeof type === 'undefined') return true;
  var isValidType = function isValidType(value, type) {
    return _typeof(value) === type;
  };
  if (type === 'string') {
    return isValidType(value, 'string');
  }
  if (type === 'number') {
    return isValidType(value, 'number');
  }
  if (type === 'integer') {
    return !isNaN(Number(value)) && Number.isInteger(value);
  }
  if (type === 'boolean') {
    return isValidType(value, 'boolean');
  }
  if (type === 'array') {
    return Array.isArray(value) || _immutable.List.isList(value);
  }
  if (type === 'object') {
    return null !== value && !(Array.isArray(value) || _immutable.List.isList(value)) && (_typeof(value) === 'object' || _immutable.Map.isMap(value) || _immutable.Record.isRecord(value));
  }
  if (type === 'null') {
    return null === value;
  }
  return false;
};
var validateTypes = exports.validateTypes = function validateTypes(value, type) {
  if (typeof value === 'undefined') return true;
  if (typeof type === 'string') {
    type = (0, _immutable.List)([type]);
  }
  return type.reduce(function (c, t) {
    return c || validateType(value, t);
  }, false);
};