"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.schemaRulesToNative = void 0;
var schemaRulesToNative = exports.schemaRulesToNative = function schemaRulesToNative() {
  var inputProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var schema = arguments.length > 1 ? arguments[1] : undefined;
  if (typeof schema.get('minLength') === 'number') {
    inputProps['minLength'] = schema.get('minLength');
  }
  if (typeof schema.get('maxLength') === 'number') {
    inputProps['maxLength'] = schema.get('maxLength');
  }
  if (typeof schema.get('minimum') === 'number') {
    inputProps['min'] = schema.get('minimum');
  }
  if (typeof schema.get('maximum') === 'number') {
    inputProps['max'] = schema.get('maximum');
  }
  if (typeof schema.get('multipleOf') === 'number') {
    inputProps['step'] = schema.get('multipleOf');
  }
  if (schema.get('pattern')) {
    inputProps['pattern'] = schema.get('pattern');
  }
  return inputProps;
};